| Home | Libraries | People | FAQ | More

##### websocket::async_teardown (1 of 2 overloads)

Start tearing down a connection.

###### Synopsis

Defined in header `<boost/beast/websocket/teardown.hpp>`

    template<
        class Socket,
        class TeardownHandler>
    void
    async_teardown(
        role_type role,
        Socket& socket,
        TeardownHandler&& handler);

###### Description

This begins tearing down a connection asynchronously. The implementation will call the overload of this function based on the `Socket` parameter used to consruct the socket. When `Stream` is a user defined type, and not a `net::ip::tcp::socket` or any `net::ssl::stream`, callers are responsible for providing a suitable overload of this function.

###### Parameters

Name | Description
--- | ---
`role` | The role of the local endpoint
`socket` | The socket to tear down.

`handler`

The completion handler to invoke when the operation completes. The implementation takes ownership of the handler by performing a decay-copy. The equivalent function signature of the handler must be:

    void handler(
        error_code const& error // result of operation
    );

Regardless of whether the asynchronous operation completes immediately or not, the handler will not be invoked from within this function. Invocation of the handler will be performed in a manner equivalent to using `net::post`.

Convenience header `<boost/beast/websocket.hpp>`